#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void    tracking( int data1 , int data2 , int data3,   /* MWPC 1-X*/                 
		  int data4 , int data5 , int data6,   /* MWPC 1-Y*/                 
		  int data7 , int data8 , int data9,   /* MWPC 2-X*/
		  int data10, int data11, int data12,  /* MWPC 2-Y*/
		  int data13, int data14, int data15,  /* MWPC 3-X*/
		  int data16, int data17, int data18,  /* MWPC 3-Y*/
		  int data19, int data20, int data21, int data22,/* MWPC 4-X*/
		  int data23, int data24, int data25, int data26 /* MWPC 4-Y*/
		  )
{
  int h,i,j,k,l,m,n;
  int x1s[17],x2s[17],x3s[17],x4s[17],x5s[17],x6s[17], 
    x7s[17],x8s[17],x9s[17],x10s[17],x11s[17],x12s[17], 
    x13s[17],x14s[17],x15s[17],x16s[17],x17s[17],x18s[17], 
    x19s[17],x20s[17],x21s[17],x22s[17],x23s[17],x24s[17], 
    x25s[17],x26s[17]; 
  unsigned int b1[17],b2[17],b3[17],b4[17],b5[17],b6[17], 
    b7[17],b8[17],b9[17],b10[17],b11[17],b12[17], 
    b13[17],b14[17],b15[17],b16[17],b17[17],b18[17], 
    b19[17],b20[17],b21[17],b22[17],b23[17],b24[17], 
    b25[17],b26[17]; 
  float  flag1,flag2,flag3,flag4,flag5,flag6, 
    flag7,flag8,flag9,flag10,flag11,flag12, 
    flag13,flag14,flag15,flag16,flag17,flag18,flag19, 
    flag20,flag21,flag22,flag23,flag24,flag25,flag26; 
  
  int total_x1[49],total_x2[49],total_x3[49],total_x4[65];
  int total_y1[49],total_y2[49],total_y3[49],total_y4[65];
  int a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12;
  int a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26;
  int check_x1,check_x2,check_x3,check_x4; 
  double hit_channel_x1,hit_channel_x2,hit_channel_x3,hit_channel_x4; 
  int check_y1,check_y2,check_y3,check_y4; 
  double single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4; 
  double single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4; 
  double hit_channel_y1,hit_channel_y2,hit_channel_y3,hit_channel_y4; 
  int x_1,x_2,x_3,x_4,y_1,y_2,y_3,y_4; 
  
  single_hit_x1 = single_hit_x2 = single_hit_x3 = single_hit_x4 = 0; 
  single_hit_y1 = single_hit_y2 = single_hit_y3 = single_hit_y4 = 0; 

  /***********************/ 
  /*      MWPC 1-X       */ 
  /***********************/ 
  x_1 = 0;
  a1=data1; 
  a2=data2; 
  a3=data3; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b1[l] = a1%2; 
      b2[l] = a2%2; 
      b3[l] = a3%2; 
      a1 = a1/2; 
      a2 = a2/2; 
      a3 = a3/2; 
    } 
  for( j=16 ; j >= 1 ; j-- ) 
    { 
      x1s[17-j]=b1[j]; 
      x2s[17-j]=b2[j]; 
      x3s[17-j]=b3[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag1=(float)x1s[k]; 
      flag2=(float)x2s[k]; 
      flag3=(float)x3s[k]; 
      x_1=x_1+(int)flag1+(int)flag2+(int)flag3;   
    }
  for(m=1;m<=16;m++) 
    { 
      total_x1[m]=x1s[m]; 
      total_x1[m+16]=x2s[m]; 
      total_x1[m+32]=x3s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 1-Y       */ 
  /***********************/ 
  y_1 = 0;
  a4=data4; 
  a5=data5; 
  a6=data6; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b4[l] = a4%2; 
      b5[l] = a5%2; 
      b6[l] = a6%2; 
      a4 = a4/2; 
      a5 = a5/2; 
      a6 = a6/2; 
    } 
  for( j=1 ; j <= 16 ; j++ ) 
    { 
      x4s[j]=b4[j]; 
      x5s[j]=b5[j]; 
      x6s[j]=b6[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag4=(float)x4s[k]; 
      flag5=(float)x5s[k]; 
      flag6=(float)x6s[k]; 
      y_1=y_1+(int)flag4+(int)flag5+(int)flag6;   
    }                 
  for(m=1;m<=16;m++) 
    { 
      total_y1[m]=x4s[m]; 
      total_y1[m+16]=x5s[m]; 
      total_y1[m+32]=x6s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 2-X       */ 
  /***********************/
  x_2 = 0;
  a7=data7; 
  a8=data8; 
  a9=data9; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b7[l] = a7%2; 
      b8[l] = a8%2; 
      b9[l] = a9%2; 
      a7 = a7/2; 
      a8 = a8/2; 
      a9 = a9/2; 
    } 
  for( j=1 ; j <= 16 ; j++ ) 
    { 
      x7s[j]=b7[j]; 
      x8s[j]=b8[j]; 
      x9s[j]=b9[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag7=(float)x7s[k]; 
      flag8=(float)x8s[k]; 
      flag9=(float)x9s[k]; 
      x_2=x_2+(int)flag7+(int)flag8+(int)flag9;   
    }
  for(m=1;m<=16;m++) 
    { 
      total_x2[m]=x7s[m]; 
      total_x2[m+16]=x8s[m]; 
      total_x2[m+32]=x9s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 2-Y       */ 
  /***********************/ 
  y_2 = 0;
  a10=data10; 
  a11=data11; 
  a12=data12; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b10[l] = a10%2; 
      b11[l] = a11%2; 
      b12[l] = a12%2; 
      a10 = a10/2; 
      a11 = a11/2; 
      a12 = a12/2; 
    } 
  for( j=16 ; j >= 1 ; j-- ) 
    { 
      x10s[17-j]=b10[j]; 
      x11s[17-j]=b11[j]; 
      x12s[17-j]=b12[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag10=(float)x10s[k]; 
      flag11=(float)x11s[k]; 
      flag12=(float)x12s[k]; 
      y_2=y_2+(int)flag10+(int)flag11+(int)flag12; 
    }
  for(m=1;m<=16;m++) 
    { 
      total_y2[m]=x10s[m]; 
      total_y2[m+16]=x11s[m]; 
      total_y2[m+32]=x12s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 3-X       */ 
  /***********************/ 
  x_3 = 0;
  a13=data13; 
  a14=data14; 
  a15=data15; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b13[l] = a13%2; 
      b14[l] = a14%2; 
      b15[l] = a15%2; 
      a13 = a13/2; 
      a14 = a14/2; 
      a15 = a15/2; 
    } 
  for( j=1 ; j <= 16 ; j++ ) 
    { 
      x13s[j]=b13[j]; 
      x14s[j]=b14[j]; 
      x15s[j]=b15[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag13=(float)x13s[k]; 
      flag14=(float)x14s[k]; 
      flag15=(float)x15s[k]; 
      x_3=x_3+(int)flag13+(int)flag14+(int)flag15; 
    }
  for(m=1;m<=16;m++) 
    { 
      total_x3[m]=x13s[m]; 
      total_x3[m+16]=x14s[m]; 
      total_x3[m+32]=x15s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 3-Y       */ 
  /***********************/
  y_3 = 0;
  a16=data16; 
  a17=data17; 
  a18=data18; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b16[l] = a16%2; 
      b17[l] = a17%2; 
      b18[l] = a18%2; 
      a16 = a16/2; 
      a17 = a17/2; 
      a18 = a18/2; 
    } 
  for( j=17 ; j >= 1 ; j-- ) 
    { 
      x16s[17-j]=b16[j]; 
      x17s[17-j]=b17[j]; 
      x18s[17-j]=b18[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag16=(float)x16s[k]; 
      flag17=(float)x17s[k]; 
      flag18=(float)x18s[k]; 
      y_3=y_3+(int)flag16+(int)flag17+(int)flag18; 
    } 
  for(m=1;m<=16;m++) 
    { 
      total_y3[m]=x16s[m]; 
      total_y3[m+16]=x17s[m]; 
      total_y3[m+32]=x18s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 4-X       */ 
  /***********************/ 
  x_4 = 0;
  a19=data19; 
  a20=data20; 
  a21=data21; 
  a22=data22; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b19[l] = a19%2; 
      b20[l] = a20%2; 
      b21[l] = a21%2; 
      b22[l] = a22%2; 
      a19 = a19/2; 
      a20 = a20/2; 
      a21 = a21/2; 
      a22 = a22/2; 
    } 
  for( j=1 ; j <= 16 ; j++ ) 
    { 
      x19s[j]=b19[j]; 
      x20s[j]=b20[j]; 
      x21s[j]=b21[j]; 
      x22s[j]=b22[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag19=(float)x19s[k]; 
      flag20=(float)x20s[k]; 
      flag21=(float)x21s[k]; 
      flag22=(float)x22s[k]; 
      x_4=x_4+(int)flag19+(int)flag20+(int)flag21+(int)flag22;   
    }
  for(m=1;m<=16;m++) 
    { 
      total_x4[m]=x19s[m]; 
      total_x4[m+16]=x20s[m]; 
      total_x4[m+32]=x21s[m]; 
      total_x4[m+48]=x22s[m]; 
    } 
  
  /***********************/ 
  /*      MWPC 4-Y       */ 
  /***********************/ 
  y_4 = 0;
  a23=data23; 
  a24=data24; 
  a25=data25; 
  a26=data26; 
  for( l=1 ; l <=16 ; l++ ) 
    { 
      b23[l] = a23%2; 
      b24[l] = a24%2; 
      b25[l] = a25%2; 
      b26[l] = a26%2; 
      a23 = a23/2; 
      a24 = a24/2; 
      a25 = a25/2; 
      a26 = a26/2; 
    } 
  for( j=17 ; j >= 1 ; j-- ) 
    { 
      x23s[17-j]=b23[j]; 
      x24s[17-j]=b24[j]; 
      x25s[17-j]=b25[j]; 
      x26s[17-j]=b26[j]; 
    } 
  for( k=1 ; k <= 16 ; k++ ) 
    { 
      flag23=(float)x23s[k]; 
      flag24=(float)x24s[k]; 
      flag25=(float)x25s[k]; 
      flag26=(float)x26s[k]; 
      y_4=y_4+(int)flag23+(int)flag24+(int)flag25+(int)flag26;   
    }
  for(m=1;m<=16;m++) 
    { 
      total_y4[m]=x23s[m]; 
      total_y4[m+16]=x24s[m]; 
      total_y4[m+32]=x25s[m]; 
      total_y4[m+48]=x26s[m]; 
    } 
  
  /*************************************************/
  /*                    tracking                   */
  /*************************************************/
  check_x1 = 0; 
  check_x2 = 0; 
  check_x3 = 0; 
  check_x4 = 0; 
  
  if( x_1 == 1 && x_2 == 1 && x_3 == 1 && x_4 == 1 ) 
    { 
      for( j = 1 ; j <= 48 ; j++ ) 
	{ 
	  if( total_x1[j] == 1 ) single_hit_x1 = (float)j; 
	  if( total_x2[j] == 1 ) single_hit_x2 = (float)j; 
	  if( total_x3[j] == 1 ) single_hit_x3 = (float)j; 
	} 
      for( j = 1 ; j <= 64 ; j++ ) 
	{ 
	  if( total_x4[j] == 1 ) single_hit_x4 = (float)j; 
	} 
      hf1(700,gradient_x( single_hit_x1,single_hit_x2, 
			  single_hit_x3,single_hit_x4),1.0); 
    } 
  
  if( x_1 == 1 ) 
    { 
      for( h = 1 ; h <= 48 ; h++ ) 
	{ 
	  if( total_x1[h] == 1 ) 
	    { 
	      hit_channel_x1 = (float)h; 
	      check_x1 = 1; 
	    } 
	} 
    } 
  if( x_1 == 2 ) 
    { 
      for( h = 1 ; h <= 47 ; h++ ) 
	{ 
	  if( total_x1[h] == 1 && total_x1[h+1] == 1) 
	    { 
	      hit_channel_x1=(float)(2*h+1)/2; 
	      check_x1 = 1; 
	    } 
	} 
    } 
  if( x_1 == 3 ) 
    { 
      for( h = 1 ; h <= 46 ; h++ ) 
	{ 
	  if( total_x1[h] == 1 && total_x1[h+1] == 1 && total_x1[h+2] == 1 ) 
	    { 
	      hit_channel_x1=(float)(h+1); 
	      check_x1 = 1; 
	    } 
	} 
    } 
  
  if( check_x1 == 1 ) 
    { 
      if( x_2 == 1 ) 
	{ 
	  for( h = 1; h <= 48 ; h++ ) 
	    { 
	      if( total_x2[h] == 1 ) 
		{ 
		  hit_channel_x2 = (float)h; 
		  check_x2 = 1; 
		} 
	    } 
	} 
      if( x_2 == 2 ) 
	{ 
	  for( h = 1 ; h <= 47 ; h++ ) 
	    { 
	      if( total_x2[h] == 1 && total_x2[h+1] ) 
		{ 
		  hit_channel_x2=(float)(2*h+1)/2; 
		  check_x2 = 1; 
		} 
	    } 
	} 
      if( x_2 == 3 ) 
	{ 
	  for( h = 1 ; h <= 46 ; h++ ) 
	    { 
	      if( total_x2[h] == 1 && total_x2[h+1] == 1 && total_x2[h+2] == 1) 
		{ 
		  hit_channel_x2=(float)(h+1); 
		  check_x2 = 1; 
		} 
	    } 
	} 
    } 
  if( check_x1==1 && check_x2==1 ) 
    { 
      if( x_3 == 1 ) 
	{ 
	  for( h = 1; h <= 48 ; h++ ) 
	    { 
	      if( total_x3[h] == 1 ) 
		{ 
		  hit_channel_x3 = (float)h; 
		  check_x3 = 1; 
		} 
	    } 
	} 
      if( x_3 == 2 ) 
	{ 
	  for( h = 1; h <= 47 ; h++ ) 
	    { 
	      if( total_x3[h] == 1 && total_x3[h+1] == 1 ) 
		{ 
		  hit_channel_x3=(float)(2*h+1)/2; 
		  check_x3 = 1; 
		} 
	    } 
	} 
      if( x_3 == 3 ) 
	{ 
	  for( h = 1 ; h <= 46 ; h++ ) 
	    { 
	      if( total_x3[h] == 1 && total_x3[h+1] == 1 && total_x3[h+2] == 1 ) 
		{ 
		  hit_channel_x3=(float)(h+1); 
		  check_x3 = 1; 
		} 
	    } 
	} 
    } 
  if( check_x1==1 && check_x2==1 && check_x3==1 ) 
    { 
      if( x_4 == 1 ) 
	{ 
	  for( h = 1; h <= 64 ; h++ ) 
	    { 
	      if( total_x4[h] == 1 ) 
		{ 
		  hit_channel_x4=(float)(h); 
		  check_x4 = 1; 
		} 
	    } 
	} 
      if( x_4 == 2 ) 
	{ 
	  for( h = 1 ; h <= 63 ; h++ ) 
	    { 
	      if( total_x4[h] == 1 && total_x4[h+1] == 1 ) 
		{ 
		  hit_channel_x4=(float)(2*h+1)/2; 
		  check_x4 = 1; 
		} 
	    } 
	} 
      if( x_4 == 3 ) 
	{ 
	  for( h = 1; h <= 62 ; h++ ) 
	    { 
	      if( total_x4[h] == 1 && total_x4[h+1] == 1 && total_x4[h+2] == 1 ) 
		{ 
		  hit_channel_x4=(float)(h+1); 
		  check_x4 = 1; 
		} 
	    } 
	} 
    } 
  /*---------------------------------------------------------------------------------*/
  
  check_y2 = 0; 
  check_y3 = 0; 
  check_y4 = 0; 
  
  if( y_1 == 1 && y_2 == 1 && y_3 == 1 && y_4 == 1 ) 
    { 
      for( j = 1 ; j <= 48 ; j++ ) 
	{ 
	  if( total_y1[j] == 1 ) single_hit_y1 = (float)j; 
	  if( total_y2[j] == 1 ) single_hit_y2 = (float)j; 
	  if( total_y3[j] == 1 ) single_hit_y3 = (float)j; 
	} 
      for( j = 1 ; j <= 64 ; j++ ) 
	{ 
	  if( total_y4[j] == 1 ) single_hit_y4 = (float)j; 
	} 
      hf1(701,gradient_y( single_hit_y1,single_hit_y2, 
			  single_hit_y3,single_hit_y4),1.0); 
    } 
  
  if( y_1 == 1 ) 
    { 
      for( h = 1; h <= 48 ; h++ ) 
	{ 
	  if( total_y1[h] == 1 ) 
	    { 
	      hit_channel_y1 = (float)h; 
	      check_y1 = 1; 
	    } 
	} 
    } 
  if( y_1 == 2 ) 
    { 
      for( h = 1 ; h <= 47 ; h++ ) 
	{ 
	  if( total_y1[h] == 1 && total_y1[h+1] == 1 ) 
	    { 
	      hit_channel_y1=(float)(2*h+1)/2; 
	      check_y1 = 1; 
	    } 
	} 
    } 
  if( y_1 == 3 ) 
    { 
      for( h = 1 ; h <= 46 ; h++ ) 
	{ 
	  if( total_y1[h] == 1 && total_y1[h+1] == 1 && total_y1[h+2] == 1) 
	    { 
	      hit_channel_y1=(float)(h+1); 
	      check_y1 = 1; 
	    } 
	} 
    } 
  if( check_y1 == 1 ) 
    { 
      if( y_2 == 1 ) 
	{ 
	  for( h = 1 ; h <= 48 ; h++ ) 
	    { 
	      if( total_y2[h] == 1 ) 
		{ 
		  hit_channel_y2 = (float)h; 
		  check_y2 = 1; 
		} 
	    } 
	} 
      if( y_2 == 2  ) 
	{ 
	  for( h = 1 ; h <= 47 ; h++ ) 
	    { 
	      if( total_y2[h] == 1 && total_y2[h+1] == 1 ) 
		{ 
		  hit_channel_y2=(float)(2*h+1)/2; 
		  check_y2 = 1; 
		} 
	    } 
	} 
      if( y_2 == 3 ) 
	{ 
	  for( h = 1 ; h <= 46 ; h++ ) 
	    { 
	      if( total_y2[h] == 1 && total_y2[h+1] == 1 && total_y2[h+2] == 1 ) 
		{ 
		  hit_channel_y2=(float)(h+1); 
		  check_y2 = 1; 
		} 
	    } 
	} 
    } 
  if( check_y1 == 1 && check_y2 == 1 ) 
    { 
      if( y_3 == 1 ) 
	{ 
	  for( h = 1 ; h <= 48 ; h++ ) 
	    { 
	      if( total_y3[h] == 1 ) 
		{ 
		  hit_channel_y3 = (float)h; 
		  check_y3 = 1; 
		} 
	    } 
	} 
      if( y_3 == 2 ) 
	{ 
	  for( h = 1 ; h <= 47 ; h++ ) 
	    { 
	      if( total_y3[h] == 1 && total_y3[h+1] == 1 ) 
		{ 
		  hit_channel_y3=(float)(2*h+1)/2; 
		  check_y3 = 1; 
		} 
	    } 
	} 
      if( y_3 == 3 ) 
	{ 
	  for( h = 1 ; h <= 46 ; h++ ) 
	    { 
	      if( total_y3[h] == 1 && total_y3[h+1] == 1 && total_y3[h+2] == 1 ) 
		{ 
		  hit_channel_y3=(float)(h+1); 
		  check_y3 = 1; 
		} 
	    } 
	} 
    } 
  if( check_y1 == 1 && check_y2 == 1 && check_y3 == 1 ) 
    { 
      if( y_4 == 1 ) 
	{ 
	  for( h = 1 ; h <= 64 ; h++ ) 
	    { 
	      if( total_y4[h] == 1 ) 
		{ 
		  hit_channel_y4=(float)(h); 
		  check_y4 = 1; 
		} 
	    } 
	} 
      if( y_4 == 2 ) 
	{ 
	  for( h = 1; h <= 63 ; h++ ) 
	    { 
	      if( total_y4[h] == 1 && total_y4[h+1] == 1 ) 
		{ 
		  hit_channel_y4=(float)(2*h+1)/2; 
		  check_y4 = 1; 
		} 
	    } 
	} 
      if( y_4 == 3 ) 
	{ 
	  for( h = 1 ; h <= 62 ; h++ ) 
	    { 
	      if( total_y4[h] == 1 && total_y4[h+1] == 1 && total_y4[h+2] == 1 ) 
		{ 
		  hit_channel_y4=(float)(h+1); 
		  check_y4 = 1; 
		} 
	    } 
	} 
    } 

  /****************************************************/ 
  /*          beam angle of multi hit event           */ 
  /****************************************************/ 
  if( check_x1 == 1 && check_x2 == 1 && check_x3 == 1 && check_x4 == 1 ) 
    { 
      hf1(800,gradient_x(hit_channel_x1,hit_channel_x2, 
			 hit_channel_x3,hit_channel_x4),1.0); 
    } 
  
  if( check_y1 == 1 && check_y2 == 1 && check_y3 == 1 && check_y4 == 1 ) 
    { 
      hf1(801,gradient_y(hit_channel_y1, 
			 hit_channel_y2,hit_channel_y3,hit_channel_y4),1.0); 
    } 
  if( x_1 == 1 && x_2 == 1 && x_3 == 1 && x_4 == 1 && 
      y_1 == 1 && y_2 == 1 && y_3 == 1 && y_4 == 1    ) 
    { 
      hf2(1001,Beam_Position_x( hit_channel_x1,hit_channel_x2,hit_channel_x3,hit_channel_x4), 
	  Beam_Position_y( hit_channel_y1,hit_channel_y2,hit_channel_y3,hit_channel_y4),1.0); 
    } 
  
  
  /***************************************************/ 
  /*                Beam tracking                    */ 
  /***************************************************/ 
  if( check_x1 == 1 && check_x2 == 1 && check_x3 == 1 && check_x4 == 1 && 
      check_y1 == 1 && check_y2 == 1 && check_y3 == 1 && check_y4 == 1    ) 
    { 
      hf2(1000, 
	  Beam_Position_x(hit_channel_x1,hit_channel_x2, 
			  hit_channel_x3,hit_channel_x4), 
	  Beam_Position_y(hit_channel_y1,hit_channel_y2, 
			  hit_channel_y3,hit_channel_y4),1.0); 
      hit_channel_x1 = hit_channel_x2 = hit_channel_x3 = hit_channel_x4 = 0; 
      hit_channel_y1 = hit_channel_y2 = hit_channel_y3 = hit_channel_y4 = 0; 
    }
}
  
